﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;

namespace WebApi_Core
{
    public class Employees
    {
        public static DataTable GetJsonEmployees()
        {
            string jsonObject = @"[{
                              'FirstName': 'Harry',
                              'LastName': 'Potter'
                             },
                             {
                              'FirstName': 'Jon',
                              'LastName': 'Snow'
                             }
                            ]";
            return CreateDataTableFromJSON("Employee", jsonObject);

        }

        public static DataTable CreateDataTableFromJSON(string name, string jsonObject)
        {
            var jsonlist = JsonConvert.DeserializeObject<List<Employee>>(jsonObject);

            var table = new DataTable(name);
            var props = typeof(Employee).GetProperties();
            foreach (var prop in props)
            {
                table.Columns.Add(prop.Name);
            }

            for (int i = 0; i < jsonlist.Count(); i++)
            {
                var jsoni = jsonlist[i];
                DataRow dr = table.NewRow();
                foreach (var prop in props)
                {
                    dr.SetField(prop.Name, prop.GetValue(jsoni));
                }
                table.Rows.Add(dr);
            }



            return table;
        }
    }
}
