﻿using C1.Web.Api.Report;
using C1.Web.Api.Report.Models;
using C1.Win.C1Document;
using C1.Win.FlexReport;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Threading.Tasks;

namespace WebApi_Core
{
    public class MemoryReportsProvider : ReportProvider
    {

        public string ReportPath { get; set; }
        public string ReportName { get; set; }

        public MemoryReportsProvider(string path, string name)
        {
            ReportPath = path;
            ReportName = name;
        }

        public override CatalogItem GetCatalogItem(string providerName, string path, bool recursive, NameValueCollection args = null)
        {
            throw new NotImplementedException();
        }

        protected override C1DocumentSource CreateDocument(string path, NameValueCollection args)
        {
            var report = new C1FlexReport();
            report.Load(ReportPath, ReportName);

            DataSource ds = new DataSource();
            ds.Name = "JSON";
            ds.Recordset = Employees.GetJsonEmployees();

            report.DataSources.Add(ds);
            report.DataSourceName = ds.Name;
            return report;
        }
    }
}
